unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function LanceAppliAttenteFin(NomFichier:string):boolean;
{permet de lancer un excutable. NomFichier est le nom avec chemin     }
{de cet excutable ou d'un raccourci qui pointe vers cet excutable.   }
{ notre programme est arrt tant que l'excutable n'est pas fini      }
{tout est arrt on ne peut donc mme plus dplacer sa fentre.        }
{ il est donc prfrable de la rendre invisible avant le lancement     }
{de cette fonction.                                                    }
{ LanceAppliAttenteFin renvoie true si le lancement s'est bien pass   }
var
  StartInfo : TStartupInfo;
  ProcessInformation : TProcessInformation;
begin
  result:=true;
  ZeroMemory(@StartInfo, sizeof(StartInfo)); // remplie de 0 StartInfo
  StartInfo.cb:=sizeof(StartInfo);
  if CreateProcess(nil,PChar(NomFichier),nil,nil,true,0,nil,nil,StartInfo,ProcessInformation)
  then WaitForSingleObject(ProcessInformation.hProcess, INFINITE)// attend que l'application dsigne par le handle ProcessInformation.hProcess soit termine
  else result:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDialog1.Execute;
  Visible:=false; //facultatif : permet de rendre invisible notre application
  if not (LanceAppliAttenteFin(OpenDialog1.FileName)) then ShowMessage('erreur au lancement de l''aplication'+ Opendialog1.FileName);
  visible:=true;  // remet visible notre application
  ShowMessage ('fini');
end;

end.
